#! /usr/bin/ruby -Ks

$fails = []
def assert(result, expect)
  if result == expect
    STDOUT.print "."
  else
    STDOUT.print "F"
    $fails.push sprintf("failed at %s\n", caller(1)[0])
    $fails.push sprintf("\t%s != %s\n", result.inspect, expect.inspect)
  end
  STDOUT.flush
end

END {
  print "\n"
  for i in $fails
    print i
  end
}

a = "abcd"
assert a, "abcd"
assert a.size, 14
assert a.length, 9
assert sprintf("%x", a[0]), "82a0"
assert sprintf("%x", a[1]), "61"

a[1] = 0x82a2
assert a, "bcd"
assert a.size, 15
assert a.length, 9

assert a.index(""), 4
assert a.index(//), 6
assert a.rindex("d"), 7
assert a.rindex(//),2

assert a.tr("", "auo"), "abucdo"
assert a.tr("abc", ""), "d"
assert a.tr("^abcd", ""), "bcd"
assert a, "bcd"
assert a.slice!(1,2), ""
assert a, "bcd"

assert "abc".delete("-", "^"), "abc"
assert "aabccdeffc".squeeze, "abcdefc"
assert "aabccdeffc".count("a"), 5
assert "aabbaa".tr_s("a", "a"), "abb"
assert "aabbaa".squeeze, "aba"


assert "a" =~ //, 1
assert $', "a"

assert "aiueo"[1,2], "iu"
assert ""[1,2], ""
assert "aiueo"[3..-1], "eo"
assert ""[3..-1], ""
assert "".sub(/./, "ud"), "ud"
assert "eXg".scan(/./), ["e", "X", "g"]
assert "Ȃ".gsub(//, "na"), "nana"

assert sprintf("<%.2s>", ""), "<>"
assert sprintf("<%12s>", ""), "<       >"
assert sprintf("<%-12s>", ""), "<       >"

assert "".split, [""]
assert "".split(//), ["", "", "", "", ""]
assert "::::".split(":"), ["", "", "", "", ""]
assert "::::".split(/:/), ["", "", "", "", ""]
assert "::::".split(/:/, 3), ["", "", "::"]

assert "".reverse, ""
assert "abcdef".reverse, "fedcba"

assert "abcdef" =~ /^#/, nil

assert "".succ, ""
assert "".replace(""), ""

a = "abcd"
assert a.upcase!, "ABCD"
assert a.downcase!, "abcd"

assert a.delete("abcd"), ""
assert a.delete(""), "abcd"

a = "  abcd  "
assert a.strip, "abcd"

a = "abcdABCD"
assert a.swapcase!, "ABCDabcd"

assert a.dump, '"\202\240A\202\242B\202\244C\202\246D\202\250\202\240a\202\242b\202\244c\202\246d\202\250"'
assert a.inspect, '"ABCDabcd"'


